#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include <math.h>

void coulev(unsigned char jo1  , unsigned char mo1 , unsigned char time[] );


void main(void) {
unsigned char jours=0, mois=0 ;
unsigned char time[4];

SOPT1=0x52; 

// Clock QG8 CPU @ 8MHz 
//  ICSTRM = *(unsigned char*far)0xFFAF; /* Initialize ICSTRM register from a non volatile memory */
//  ICSSC = *(unsigned char*far)0xFFAE;  /* Initialize ICSSC register from a non volatile memory */
//  ICSC1 = 0x04;                        /* Initialization of the ICS control register 1 */
//  ICSC2 = 0x00;                        /* Initialization of the ICS control register 2 */


// Clock initialization AW 60 CPU @ 20Mhz  
//  SMCLK &= (unsigned char)~0x17;                    
//  ICGC1 = 0x4C;                                      
//  ICGC2 = 0x70;                                      
//  ICGTRM = *(unsigned char*far)0xFFBE; /* Initialize ICGTRM register from a non volatile memory */
//  while(!ICGS1_LOCK) { /* Wait */  }

  EnableInterrupts; /* enable interrupts */
  /* include your code here */

  for(;;) {
  jours++           ;
  mois++        ;
   asm nop ;
  
  coulev(jours, mois, time) ;
                        
    __RESET_WATCHDOG(); /* feeds the dog */
  } /* loop forever */
  /* please make sure that you never leave main */
}






void coulev(unsigned char jo1  , unsigned char mo1 , unsigned char time[] ) {
  
//  Constantes
 float k = 0.0172024;
 float jm = 308.67 ;
 float jl = 21.55  ;
 float e = 0.0167  ;
 float ob = 0.4091 ;  
 float pi = 3.141593; float dr = pi / 180.0 ; float hr = pi / 12.0 ;

// Hauteur du soleil au lever et au coucher
float lo=0.0,la=0.0,h=0.0,j=0.0,s=0.0,x=0.0,y=0.0,z=0.0,l=0.0,r=0.0,
et=0.0,fh=0.0, m=0.0, pm=0.0,hs=0.0,dc=0.0, rx=0.0,ry=0.0, cs=0.0,ah=0.0;

float jo ; float mo ;
float ht = -50.0 / 60.0; 

ht = ht * dr ;

jo = (float)jo1 ;
mo = (float)mo1 ;

// Fuseau horaire et coordonnes gographiques
fh = 1.0 ;// Bruxellles
// Longitude (en degrs, positive  l'ouest)"; lo
lo = -4.3496 ; //  Bruxellles
lo = lo * dr ;
// Latitude (en degrs)
la = 50.8492 ; //  Bruxellles
la = la * dr ;


if(mo<3.0) mo=mo+12.0; 
// Heure TU du milieu de la journe
h = 12.0 + lo / hr ;
// Nombre de jours couls depuis le 1 Mars O h TU
j = floor(30.61 * (mo + 1.0)) + jo + h / 24.0 - 123.0 ;
// Anomalie et longitude moyenne
m = k * (j - jm) ; l = k * (j - jl);
// Longitude vraie
s = l + 2.0* e * sinf(m) + 1.25 * e * e * sinf(2 * m) ;
// Coordonnes rectangulaires du soleil dans le repre quatorial
x= sinf(s) ; //test
x = cosf(s); y = cosf(ob) * sinf(s); z = sinf(ob) * sinf(s)  ;

// Equation du temps et dclinaison
r = l ; 
// Rotation de l'angle r autour de l'axe z
rx = cosf(r) * x + sinf(r) * y; ry = -sinf(r) * x + cosf(r) * y   ;
x=rx ; y=ry;
et = atanf(y / x) ;
dc = atanf(z / sqrtf(1.0 - z * z))  ;

/*
//Heure du passage au mridien (midi vrai): hs; ms; pm
pm = h + fh + et / hr  ;
hs = floor(pm); pm = 60.0 * (pm - hs) ;
ms = floor(pm); pm = 60.0 * (pm - ms) ;

*/
// Angle horaire au lever et au coucher
cs = (sinf(ht) - sinf(la) * sinf(dc)) / cosf(la) / cosf(dc) ;
if (cs > 1.0) {asm nop ;};//Le soleil ne se lve pas 
if (cs < -1.0) { asm nop ;};//Le soleil ne se couche pas
if (cs == 0.0 ) {ah = pi / 2.0 ;} else { ah = atanf(sqrtf(1 - cs * cs) / cs); };
if (cs < 0.0 ){ah = ah + pi;};

// Lever du soleil
pm = h + fh + (et - ah) / hr ;
if (pm < 0.0) {pm = pm + 24.0;} ;
hs = floor(pm); pm = 60.0 * (pm - hs) ;
 time[0]=(unsigned char)hs;
 time[1]=(unsigned char)floor(pm);

// Coucher du soleil
pm = h + fh + (et + ah) / hr   ;
if ( pm > 24.0) {pm = pm - 24.0 ;};
hs = floor(pm); pm = 60.0 * (pm - hs);
 time[2]=(unsigned char)hs;
 time[3]=(unsigned char)floor(pm);

}
